package nl.nikhef.safaripark.dolly;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;
import java.util.Properties;

import nl.nikhef.sfp.ddmi.DDMIValue;
import nl.nikhef.tools.Utils;

public class FileValueSetter implements ValueSetter {

	private Properties _props;
	private File       _target;
	
	public FileValueSetter(File targetFile) 
	{
		_props = new Properties();
		_target = targetFile;
	}

	@Override
	public void setValue(DDMIValue value, byte[] data) throws IOException 
	{
		String qName = value.getQualifiedName();
		_props.setProperty(qName, Utils.bytesToHexString(data));
	}

	@Override
	public void finished() throws IOException {
		Writer w = new FileWriter(_target);
		try {
			_props.store(w, "SFP Module Values file");
		} finally {
			try {
				w.close();
			} catch (IOException e) { }	// prevent close exception from overwriting the actual error
		}
	}

}
